/*
 * Copyright 2003-2011 Optimatika (www.optimatika.se)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package org.ojalgo.gui.layout;

import java.awt.Component;
import java.awt.GraphicsConfiguration;
import java.awt.GridBagLayout;
import java.awt.HeadlessException;
import java.awt.Insets;

import javax.swing.JFrame;

/**
 * 
 * @deprecated v31 Will be removed or seriously refactored
 * @author apete
 */
@Deprecated
public abstract class GridBagFrame extends JFrame implements GridBagComponent {

    private final ConstraintsBuilder myConstraintsFactory = new ConstraintsBuilder();;

    @SuppressWarnings("unused")
    private GridBagFrame() throws HeadlessException {
        super();
    }

    @SuppressWarnings("unused")
    private GridBagFrame(final GraphicsConfiguration someGc) {
        super(someGc);
    }

    @SuppressWarnings("unused")
    private GridBagFrame(final String someTitle) throws HeadlessException {
        super(someTitle);
    }

    @SuppressWarnings("unused")
    private GridBagFrame(final String someTitle, final GraphicsConfiguration someGc) {
        super(someTitle, someGc);
    }

    protected GridBagFrame(final int aRowDim, final int aColDim) {

        super();

        this.setLayout(new GridBagLayout());

        GridBagComponent.ConstraintsBuilder.initialiseLayout(this, aRowDim, aColDim, true);
    }

    protected GridBagFrame(final int[] someRowHeights, final int[] someColWidths) {

        super();

        this.setLayout(new GridBagLayout());

        GridBagComponent.ConstraintsBuilder.initialiseLayout(this, someRowHeights, someColWidths, true);
    }

    /**
     * @see org.ojalgo.gui.layout.GridBagComponent#add(java.awt.Component, int, int)
     */
    public void add(final Component aComponent, final int gridx, final int gridy) {
        this.add(aComponent, myConstraintsFactory.build(gridx, gridy));
    }

    /**
     * @see org.ojalgo.gui.layout.GridBagComponent#add(java.awt.Component, int, int, int, int)
     */
    public void add(final Component aComponent, final int gridx, final int gridy, final int gridwidth, final int gridheight) {
        this.add(aComponent, myConstraintsFactory.build(gridx, gridy, gridwidth, gridheight));
    }

    public GridBagFrame anchor(final int anchor) {
        myConstraintsFactory.anchor(anchor);
        return this;
    }

    public GridBagFrame fill(final int fill) {
        myConstraintsFactory.fill(fill);
        return this;
    }

    public GridBagFrame insets(final Insets insets) {
        myConstraintsFactory.insets(insets);
        return this;
    }

    public void makeColumnHeavyweight(final int aCol) {
        GridBagComponent.ConstraintsBuilder.makeColumnHeavyweight(this, aCol);
    }

    public void makeRowHeavyweight(final int aRow) {
        GridBagComponent.ConstraintsBuilder.makeRowHeavyweight(this, aRow);
    }

}
