/*
 * Copyright 2003-2011 Optimatika (www.optimatika.se)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package org.ojalgo.series;

import java.util.Comparator;
import java.util.Map;
import java.util.SortedMap;

import org.ojalgo.type.CalendarDateUnit;

/**
 * TimeInMillisSeries
 *
 * @deprecated v31
 * @author apete
 */
@Deprecated
public class TimeInMillisSeries<N extends Number> extends AbstractSeries<Long, N, TimeInMillisSeries<N>> {

    public TimeInMillisSeries() {
        super();
    }

    public <K extends Comparable<K>> TimeInMillisSeries(final BasicTimeSeries<K, N> aTimeSeries) {

        this(aTimeSeries.getTimeInMillisSeries());

        this.setName(aTimeSeries.getName());
        this.setColour(aTimeSeries.getColour());
    }

    public TimeInMillisSeries(final Comparator<? super Long> aComparator) {
        super(aComparator);
    }

    public TimeInMillisSeries(final Map<? extends Long, ? extends N> aMap) {
        super(aMap);
    }

    public TimeInMillisSeries(final SortedMap<Long, ? extends N> aSortedMap) {
        super(aSortedMap);
    }

    /**
     * @return The average number of millis between to subsequent keys in the series.
     */
    public long getAverageStepSize() {
        return ((this.lastKey() - this.firstKey()) / (this.size() - 1));
    }

    public CalendarSeries<N> toCalendarSeries() {
        return new CalendarSeries<N>(this, CalendarDateUnit.MILLIS);
    }

    public DateSeries<N> toDateSeries() {
        return new DateSeries<N>(this, CalendarDateUnit.MILLIS);
    }

}
