/*
 * Copyright 2003-2011 Optimatika (www.optimatika.se)
 *
 * Regardless of how you got access to this file;
 * the code is not yours, and you're not allowed to use it in any way.
 */
package org.ojalgo.type.attribute;

import org.ojalgo.type.StandardType;
import org.ojalgo.type.context.StringContext;

public interface TypeAttribute extends StringAttribute {

    static final class WrappedKey implements TypeAttribute {

        private final char myTypeKey;

        protected WrappedKey(final char aTypeKey) {

            super();

            myTypeKey = aTypeKey;
        }

        protected WrappedKey(final String aTypeDefinition) {
            this(aTypeDefinition.toUpperCase().trim().charAt(0));
        }

        @Override
        public boolean equals(final Object someObj) {
            if (someObj instanceof WrappedKey) {
                return this.hashCode() == someObj.hashCode();
            } else {
                return false;
            }
        }

        public WrappedKey getType() {
            return this;
        }

        public String getTypeKey() {
            return String.valueOf(myTypeKey);
        }

        @Override
        public int hashCode() {
            return myTypeKey;
        }

        @Override
        public String toString() {
            return String.valueOf(myTypeKey);
        }

    }

    final StringContext CONTEXT = StandardType.STRING_1;

    WrappedKey getType();

    /**
     * A 1-character {@link String}.
     */
    String getTypeKey();

}
