/*
 * Copyright 2003-2011 Optimatika (www.optimatika.se)
 *
 * Regardless of how you got access to this file;
 * the code is not yours, and you're not allowed to use it in any way.
 */
package org.ojalgo.type.structure;

import java.util.List;

public interface HierarchyStructure<T extends HierarchyStructure<T>> {

    List<T> getChildren();

    T getParent();

    /**
     * @return true if {@link #getChildren()} returns null or an empty list
     */
    boolean isLeaf();

    /**
     * @return true if {@link #getParent()} returns null or "this"
     */
    boolean isRoot();

}
